<?php

// ---------------------------------------------------------------------------
//
// PIVOT - LICENSE:
//
// This file is part of Pivot. Pivot and all its parts are licensed under 
// the GPL version 2. see: http://www.pivotlog.net/help/help_about_gpl.php
// for more information.
//
// ---------------------------------------------------------------------------


// lamer protection
if (strpos($pivot_path,"ttp://")>0) {	die('no');}
$scriptname = basename((isset($HTTP_SERVER_VARS['PATH_INFO'])) ? $HTTP_SERVER_VARS['PATH_INFO'] : $HTTP_SERVER_VARS['PHP_SELF']);
if (!isset($_GET)) { 
	$checkvars = array_merge($HTTP_GET_VARS , $HTTP_POST_VARS, $HTTP_SERVER_VARS, $HTTP_COOKIE_VARS);
} else {
	$checkvars = array_merge($_GET , $_POST, $_SERVER, $_COOKIE);
}
if ( (isset($checkvars['pivot_url'])) || (isset($checkvars['log_url'])) || (isset($checkvars['pivot_path'])) ) {
	die('no');
}
// end lamer protection



include_once($pivot_path."modules/module_snippets.php");

// ----------------------------------------------------
// first the general functions we use to generate pages
// ----------------------------------------------------
// Eventually, these will all be changed into one Class.


// parse entry parses an entry, given an id.
// the entry is saved, if specified so in $Weblogs,
// The global var $entry_html contains the parsed html
function parse_entry($id, $weblog="", $stopafterfirst=FALSE) {
	global $Weblogs, $db, $Current_weblog, $override_template;


	// if no entry is set, or the passed id differs from the one that's in $db->entry
	// we'll have to load it..
	if ( (!isset($db->entry['code'])) || ($id != $db->entry['code'])  ) {

		$db = new db(TRUE);
		if ($db->entry_exists($id)) {
			$entry = $db->read_entry($id);
		} else {
			piv_error("Entry Does not Exist!", "That entry either doesn't exist, or it isn't published yet.", 0);
		}
	}

	//if it's not set to 'publish', display the nondescript error as well
	if ($db->entry['status']!="publish") {
		piv_error("Entry Does not Exist!", "That entry either doesn't exist, or it isn't published yet.", 0);
	}

	// figure out what weblogs this entry is in
	if ($weblog!="") {

		// if we override the template by setting a weblog, load it here.
		$Current_weblog=$weblog;

		// switch to weblog's language
		LoadWeblogLanguage($Weblogs[$Current_weblog]['language']);

		$template= $Weblogs[$weblog]['entry_template'];
		$html = generate_html($template, $weblog);

	} else {

		$in_weblogs = find_weblogs_with_cat($db->entry['category']);
	
		if (count($in_weblogs)==0) {
			piv_error("Error creating page!", "That entry either isn't published in any categories, or there is no weblog that publicizes that category.", 0);

		}

		foreach ($in_weblogs as $in_weblog) {

			$Current_weblog=$in_weblog;

			// switch to weblog's language
			LoadWeblogLanguage($Weblogs[$Current_weblog]['language']);

			// if we override a template by explicitly overriding it, load it here.
			if (isset($override_template)) {
				$template = $override_template;
			} else {
				$template= $Weblogs[$in_weblog]['entry_template'];
			}
			$html = generate_html($template, $in_weblog);

			if ($stopafterfirst) {
				break;
			}		
		}
	}

	return $html;

}


function generate_html($template, $weblog) {
	global $db, $Weblogs, $Current_weblog, $totalfiles, $set_output_paths;

	// Generate some html
	$template_html = load_template($template);

	$Current_weblog = $weblog;

	// should be unset before each archive and frontpage..
	$set_output_paths=FALSE;

	if (!($template_html)) {
		ErrorOut("Could not load template file: <i>$template</i> [does not exist]");
	} else {
		$output = $template_html;
		$output = parse_step4($output);
		$output = tidy_html($output);
	}

	// save the entry, if necessary..
	if ($Weblogs[$Current_weblog]['live_entries']<>1) {
	
		$filename =  make_filename();

		makedir($Weblogs[$Current_weblog]['entry_path']);

		add_log("Write entry file: $filename");
		write_file($filename, $output);

	}
	
	return $output;

	

}

function generate_frontpage($weblog) {
	global $Current_weblog, $Weblogs, $done_archives, $totalfiles, $Cfg, $base_url, $Allow_RSS, $set_output_paths;

	// make a key for this page
	$archive_key = $weblog."-front";

	// return, if this page has already been made.
	if ( isset($done_archives[$archive_key]) && $done_archives[$archive_key] ) {
		return;
	} else {
		$done_archives[$archive_key]=TRUE;
	}

	// switch to weblog's language
	LoadWeblogLanguage($Weblogs[$Current_weblog]['language']);

	$template_html = load_template($Weblogs[$weblog]['front_template']);

	 if ( ($Weblogs[$weblog]['rss']==1) && ($Allow_RSS) ) {
			start_rss();
	 }
	
	// should be unset before each archive and frontpage..
	$set_output_paths=FALSE;

	if (!($template_html)) {
		ErrorOut("Could not load template file: <i>$template</i> [does not exist]");
	} else {
		$output = $template_html;
		$output = parse_step4($output);
		$output = tidy_html($output);
	}

	$filename = $Weblogs[$weblog]['front_path'] . $Weblogs[$weblog]['front_filename'];

	//make sure the directory exists
	makedir($Weblogs[$weblog]['front_path']);

	add_log("Write frontpage file: $filename");
	write_file($filename, $output);

	$totalfiles++;
	debug("total_f: $filename - $totalpages");

	// finish RSS
	if ( ($Weblogs[$weblog]['rss']==1) && ($Allow_RSS) ) {
		finish_rss();
	}


	$weblogname= urlencode($Weblogs[$Current_weblog]['name']);
	$filename = urlencode(fixpath($base_url.$filename));

	return $filename;

}




function generate_archive($weblog, $date) {
	global $Current_weblog, $Weblogs, $done_archives, $totalfiles, $set_output_paths;

	// make a key for this archive
	$archive_key = $weblog."-".make_archive_name($date);

	// return, if this archive has already been made.
	if ( isset($done_archives[$archive_key]) && $done_archives[$archive_key] ) {
		return;
	} else {
		$done_archives[$archive_key]=TRUE;
	}

	// switch to weblog's language
	LoadWeblogLanguage($Weblogs[$Current_weblog]['language']);
	
	$template_html = load_template($Weblogs[$weblog]['archive_template']);
	$template_html = str_replace("[[weblog", "[[archive", $template_html);
	$template_html = str_replace("[[subweblog", "[[archive", $template_html);

	$filename = $Weblogs[$weblog]['archive_path'] . make_archive_name($date);


	// should be unset before each archive and frontpage..
	$set_output_paths=FALSE;

	if (!($template_html)) {
		ErrorOut("Could not load template file: <i>$template</i> [does not exist]");
	} else {
		$output = $template_html;
		$output = parse_step4($output);
		$output = tidy_html($output);
	}

	//make sure the directory exists
	makedir($Weblogs[$weblog]['archive_path']);
	
	add_log("Write archive file: $filename");
	write_file($filename, $output);

	$totalfiles++;
	debug("total_a: $date - $filename");
	

}

// one function, to generate entries, frontpages and archives
function generate_pages($id, $singlepage=TRUE, $frontpage=TRUE, $archive=TRUE, $ping=FALSE, $rss= TRUE) {
	global $db, $Weblogs, $Current_weblog, $Allow_RSS;
		
	//LoadTempLanguage();

	$Allow_RSS = $rss;

	// load an entry
	$entry = $db->read_entry($id, TRUE);

	$in_weblogs = find_weblogs_with_cat($entry['category']);

	foreach ($in_weblogs as $in_weblog) {

		$entry = $db->read_entry($id);
		$org_date = $entry['date'];

		$Current_weblog=$in_weblog;
		$template= $Weblogs[$in_weblog]['entry_template'];

		// we generate the single entry..
		if ($Weblogs[$in_weblog]['live_entries']<>1) {
			generate_html($template, $in_weblog);
		}

		// generate the archives
		if ($archive && $Weblogs[$Current_weblog]['archive_unit']!='none')  {
			generate_archive($in_weblog, $org_date);
		}

		// generate the frontpage
		if ($frontpage) {
			$filename = generate_frontpage($in_weblog);
		}

		// if we need to ping. do here:
		if ($ping) {

		  $path = $Weblogs[$in_weblog]['front_path'].$Weblogs[$in_weblog]['front_filename'];

			open_ping_window($in_weblog, $path);
		}


		LoadUserLanguage();

	}


}


// ----------------------------------------------------
// Then the functions in which the actual parsing takes place
// ----------------------------------------------------


function parse_step4 ($text) {
		
	preg_match_all ("|\[\[(.*)\]\]|U", $text, $match, PREG_PATTERN_ORDER);

	foreach($match[1] as $snippet_code) {
		$snippet_replace= snippet_parse ( $snippet_code );
		$text=str_replace("[[".$snippet_code."]]", $snippet_replace, $text);
	}

	return $text;
}


function parse_intro_or_body ($text, $strip="") {
	global $db, $Weblogs, $Current_weblog;
	
	$output = $text;
	
	if ($strip=="strip") {
		$output = strip_tags($output,"<a><b><i><u><embed><strong><ol><li><ul>");
	} 

	if ($db->entry['convert_lb']==1) {
		$output = convert_linebreaks( $output );
	} else if ($db->entry['convert_lb']==2) {
		$output = pivot_textile( $output );

	}


	// emoticons..
	if ($Weblogs[$Current_weblog]['emoticons']==1) {
		$output=emoticonize( $output );
	}

	// targetblank
	if ($Weblogs[$Current_weblog]['target_blank']>0) {
		$output =targetblank( $output );
	}

	$output = parse_step4( $output );

 	return tidy_html($output);

}

// ------------------------------------------
// These functions are used to tidy up the general nastyness 
// in html generated by wysiwyg editors in IE and Mozilla,

function tidy_html($text, $thorough=FALSE) {

	// clean up empty paragraphs
	$text = preg_replace("/<p>\s*<\/p>/Ui", "</p>", $text);

	// clean <p><p> and </p></p>
	$text = preg_replace("/<p([^>]*)>\s*<p([^>]*)>/Ui", "<p\\1\\2>", $text);
	$text = preg_replace("/<\/p>\s*<\/p>/Ui", "</p>", $text);
	
	// after this, we might end up starting with a closing </p>. We don't want that.
	$text = preg_replace("/^\s*<\/p>/Ui", "", $text);

	// clean up <div>'s in <p>'s
	$text = preg_replace("/<p>\s*<div(.*)>(.*)<\/div>\s*<\/p>/Ui", "<div\\1>\\2</div>\n", $text);
	

	$text = preg_replace_callback("/<p>(\s*)<div(.*)>(.*)<\/div>(\s*)<\/p>/Ui", "tidy_html_callback_nesteddivs", $text);
	// original
	// $text = preg_replace_callback("/<p>(.*)<div(.*)>(.*)<\/div>(.*)<\/p>/Ui", "tidy_html_callback_nesteddivs", $text);
	
	
	if ($thorough) {
		$text = preg_replace_callback("/<(.*)>/Ui", 'tidy_html_callback', $text);
	}

	return $text;

}

function tidy_html_callback($match) {

	$match = $match[0];

	//first, change the tag to lowercase (added the "." because otherwise it breaks my editor's syntax highlighting)
	$match = preg_replace_callback("/<(\/"."*)([a-z]+)([\s|>])/i", "tidy_html_callback_changetag", $match);

	//then, change attributes to lowercase, making sure they are quoted..
	$match = preg_replace_callback('/(\s[a-z]+)="(([^"\\\\]|\\.)+)"/i', "tidy_html_callback_doublequote", $match);
	$match = preg_replace_callback('/(\s[a-z]+)=([a-z0-9]+)/i', "tidy_html_callback_doublequote", $match);
	$match = preg_replace_callback("/(\s[a-z]+)='(([^'\\\\]|\\.)+)'/i", "tidy_html_callback_singlequote", $match);
	
	//this one doesn't work..
	//$match = preg_replace_callback("/\s([a-z]+)=([\s>])/i", "tidy_html_callback_novalueattr", $match); 


	
	// change 'optional' non closing tags to resemble proper xhtml..
	$match = preg_replace("/<br([^\/]*)>/Ui", "<br \\1 />", $match);
	$match = preg_replace("/<hr([^\/]*)>/Ui", "<hr \\1 />", $match);
	$match = preg_replace("/<img([^\/]*)>/Ui", "<img \\1 />", $match);
	$match = preg_replace("/<input([^\/]*)>/Ui", "<input \\1 />", $match);

	return $match;
}


function tidy_html_callback_changetag($match) {
	return "<".$match[1].strtolower($match[2]).$match[3];
}


function tidy_html_callback_doublequote($match) {
	return strtolower($match[1])."=\"".$match[2]."\"";
}


function tidy_html_callback_singlequote($match) {
	return strtolower($match[1])."='".$match[2]."'";
}


function tidy_html_callback_novalueattr($match) {
	
	echo "<pre>";
 print_r($match);
 echo "</pre>";

	return " ".strtolower($match[1])."='".$match[1]."'".$match[2];
}


function tidy_html_callback_nesteddivs($match) {
	
	$output="";

	if (strlen(trim($match[1]))>2) { $output .= "<p>".trim($match[1])."</p>\n"; }

	$output .= "<div".$match[2].">".$match[3]."</div>\n";

	if (strlen(trim($match[4]))>2) { $output .= "<p>".trim($match[1])."</p>\n"; }

	return $output;
}



// -- End tidy functions ---------------


function snippet_parse($snippet_code) {

	@list($command, $para1, $para2,$para3,$para4,$para5)= preg_split("/:(?!\/\/)/", $snippet_code, -1);
	
	$insert="";

	$command=str_replace("/","slash",$command);

	$function="snippet_".$command;
	if (function_exists($function)) {
		$insert=$function($para1, $para2,$para3,$para4,$para5);
	} else {
		$insert="<!-- snippet '$command' is not defined -->";
		debug ("snippeterror: $command");

	}
	
	return $insert;

}



// ----------------------------------------------------
// Finally some auxillary functions.
// ----------------------------------------------------

function load_template($basename) {
	global $template_cache;

	$filename="templates/$basename";

	if (isset($template_cache[$basename])) {
		return $template_cache[$basename];
	} else {
		if (!(file_exists($filename))) { 
			$filename="templates/longentry.html";
		}
		if (!(file_exists($filename))) { 
			$filename="templates/blogentry.html";
		}

		$filetext=implode("", file($filename));
	
		$template_cache[$basename]=$filetext;
		
		return $filetext;
	}

}



// =============================================
// the functions below are used for processing the <cms> tags
// into <html>.
// =============================================

function cms_tag_weblog($tag_attr, $tag_default){
	global $db,  $Cfg, $current_date, $Weblogs, $Current_weblog, $Current_subweblog, $base_url, $diffdate_lastformat;

	// some people use [[subweblog]] inside an entry page. to allow this
	// we need to 'store' the entry, make the subweblog, and 'restore'
	// the entry..
	if (isset($db->entry)) {     $temp_entry = $db->entry; }

	
	$order=get_attr_value('order', $tag_attr);
	if ($order=="firsttolast") { 
		$order="asc"; 
	} else { 
		$order="desc"; 
	}
	
	$countshow=0;
	$output="";

	// start output of RSS, if necessary
	if  ( (isset($global_pref['rss'])) && ($global_pref['rss']!="") ) { start_rss(); }

	// to force the 'diffdate' to start anew on each (sub)weblog.. 
	$diffdate_lastformat="";

	$subweblog=get_attr_value('subweblog', $tag_attr);
	$Current_subweblog = $subweblog;

	$tag_default_orig= implode("", file("templates/".$Weblogs[$Current_weblog]['sub_weblog'][$subweblog]['template']));

	// safety check to prevent recursive weblogs..
	if (preg_match("/\[\[weblog:(.*)(:[0-9]*)?\]\]/mUi", $tag_default_orig)) {
		 $tag_default_orig = "<p>(You can't recursively use [weblogs]!)</p>";
	}

	$show = $Weblogs[$Current_weblog]['sub_weblog'][$subweblog]['num_entries'];
	$cats = $Weblogs[$Current_weblog]['sub_weblog'][$subweblog]['categories'];
	$offset = $Weblogs[$Current_weblog]['sub_weblog'][$subweblog]['offset'];


	$db->disallow_write();
	$list_entries = $db->getlist_end(-$show-$offset,"",$cats);

	if (count($list_entries)>0) {
		foreach ($list_entries as $list_entry) {	
			// if offset > 0, we need to skip this entry
			if ($offset>0) { 	
				$offset--; 
				continue; 
			}
			
			$entry = $db->read_entry($list_entry['code']);
			if ( (!isset($entry['status'])) || ($entry['status']=='publish') ) {				

				// include an anchor, if it's not set manually with the [[id_anchor]] tag					
				if (strpos($tag_default_orig, "[[id_anchor]]")==0) {
					$entry_html = "<span id='e".$db->entry['code']."'></span>";
				} else {
					$entry_html ="";
				}
								
				$entry_html .= parse_step4($tag_default_orig);
				
				$output.=$entry_html;
				if ($Weblogs[$Current_weblog]['rss']==1) {
					add_rss($entry['code'], $entry['date'], $entry['title'], $entry['introduction'], $entry['body'], $entry['user'], $entry['category'] ); 
				}				
			}
		}
	}

	// perhaps restore the entry
	if (isset($temp_entry)) { $db->set_entry($temp_entry); }

	return $output;

}



function cms_tag_archive($tag_attr, $tag_default){
	global $db,  $Cfg, $current_date, $Weblogs, $Current_weblog, $base_url, $diffdate_lastformat;

	$order=get_attr_value('order', $tag_attr);
	if ($order=="firsttolast") { 
		$order="asc"; 
	} else { 
		$order="desc"; 
	}
	
	$countshow=0;
	$output="";

	// start output of RSS, if necessary
	if  ( (isset($global_pref['rss'])) && ($global_pref['rss']!="") ) { start_rss(); }

	// to force the 'diffdate' to start anew on each (sub)weblog.. 
	$diffdate_lastformat="";

	$subweblog=get_attr_value('subweblog', $tag_attr);


	if ( (file_exists("templates/".$Weblogs[$Current_weblog]['sub_weblog'][$subweblog]['template'])) && ($Weblogs[$Current_weblog]['sub_weblog'][$subweblog]['template'] != "") ) {
		$tag_default_orig= implode("", file("templates/".$Weblogs[$Current_weblog]['sub_weblog'][$subweblog]['template']));
	} else {
		debug("cant open file: ".$Weblogs[$Current_weblog]['sub_weblog'][$subweblog]['template']);
		debug(" - for weblog ".$Current_weblog.", subweblog ".$subweblog);
		$tag_default_orig = "";
	}

	// safety check to prevent recursive weblogs..
	if (preg_match("/\[\[weblog:(.*)(:[0-9]*)?\]\]/mUi", $tag_default_orig)) {
		 $tag_default_orig = "<p>(You can't recursively use [weblogs]!)</p>";
	}

	$show = $Weblogs[$Current_weblog]['sub_weblog'][$subweblog]['num_entries'];
	$cats = $Weblogs[$Current_weblog]['sub_weblog'][$subweblog]['categories'];

	list($start_date, $stop_date) = getdaterange($db->entry['date'], $Weblogs[$Current_weblog]['archive_unit'] );
	
	$db->disallow_write();
	$list_entries = $db->getlist_range($start_date, $stop_date,"",$cats, FALSE);

	foreach ($list_entries as $list_entry) {
		$entry = $db->read_entry($list_entry['code']);
		if ( (!isset($entry['status'])) || ($entry['status']=='publish') ) {		

				// include an anchor, if it's not set manually with the [[id_anchor]] tag					
				if (strpos($tag_default_orig, "[[id_anchor]]")==0) {
					$entry_html = "<span id='e".$db->entry['code']."'></span>";
				} else {
					$entry_html ="";
				}
								
				$entry_html .= parse_step4($tag_default_orig);			
			$output.=$entry_html;
		}
	}

	return $output;

}


function cms_tag_comments($tag_attr, $tag_default){
	global $db, $global_pref, $row, $block, $Current_weblog, $Weblogs, $Paths;

	// load the functions for ip-blocking, if necessary..
	include_once "modules/module_ipblock.php";

	if (strlen($Weblogs[$Current_weblog]['comment_format'])>1) {
		$format = $Weblogs[$Current_weblog]['comment_format'];
	} else {
		$format = "%anchor%<p>%comment%</p><p><small><b>%name%</b> %email% %url% - %date%</small></p>";
	}
	
	$content_code=get_attr_value('content_code', $tag_attr);	
	$nocomments=get_attr_value('ifnocomments', $tag_attr);
	$comments=get_attr_value('ifcomments', $tag_attr);
	$entrydate=$Weblogs[$Current_weblog]['fulldate_format'];

	if ($content_code=="") { $content_code=$row["code"]; }

	$output='<a id="comm"></a>';
	$last_comment="";

	if ((isset($db->entry['comments']))&&(count($db->entry['comments'])>0)) {
		foreach ($db->entry['comments'] as $temp_row) {

			// this is a record we have to output in some form..

			$temp_row['name'] = strip_tags($temp_row['name']);
			$temp_row['email'] = strip_tags($temp_row['email']);
			$temp_row['url'] = strip_tags($temp_row['url']);

			if ( ($temp_row["ip"].$temp_row["comment"]!=$last_comment) && (!(ip_check_block($temp_row["ip"]))) ){
		

				if (isemail($temp_row["email"])) {

					$email_format = "(".encodemail_link($temp_row["email"], "email", $temp_row["name"]).")";
					$emailtoname = encodemail_link($temp_row["email"], $temp_row["name"], $temp_row["name"]);

				} else {

					$email_format = "";
					$emailtoname = "";

				}
				
				if (isurl($temp_row["url"])) {
					if (strpos($temp_row["url"], "ttp://") < 1 ) {
						$temp_row["url"]="http://".$temp_row["url"];
					}

					$target= ($Weblogs[$Current_weblog]['target_blank']==1) ? " target='_blank'" : "";

					$temp_row["url_title"]= str_replace('http://', '', $temp_row["url"]);

					//perhaps redirect the link..
					if (isset($Weblogs[$Current_weblog]['lastref_redirect'])  && 
						($Weblogs[$Current_weblog]['lastref_redirect']==1) ) {
						$temp_row["url"] = str_replace("http://", $Paths['pivot_url']."includes/re.php?http://",  $temp_row["url"]);
					} 
					
					$url_format = sprintf("(<a href='%s' $target title='%s'>link</a>)", 
												$temp_row["url"], ($temp_row["url_title"]));
					$urltoname = sprintf("<a href='%s' $target title='%s'>%s</a>", 
												$temp_row["url"], ($temp_row["url_title"]), $temp_row['name']);
					
				} else {

					$url_format = "";
					$urltoname = "";

				}

				$anchor = "<a id=\"" . safe_string($temp_row["name"],TRUE) ."-". format_date($temp_row["date"],"%ye%%month%%day%%hour24%%minute%") ."\"></a>";

				$this_tag= $format;
				//$this_tag= str_replace("%uid%", $temp_row["uid"], $this_tag);
				$this_tag= str_replace("%ip%", $temp_row["ip"], $this_tag);
				$this_tag= str_replace("%date%", format_date($temp_row["date"],$entrydate), $this_tag);
				$this_tag= str_replace("%comment%", comment_format($temp_row["comment"]), $this_tag);
				$this_tag= str_replace("%name%", $temp_row["name"], $this_tag);
				$this_tag= str_replace("%email%", $email_format, $this_tag);
				$this_tag= str_replace("%url%", $url_format, $this_tag);
				$this_tag= str_replace("%anchor%", $anchor, $this_tag);
				$this_tag= str_replace("%url-to-name%", $urltoname, $this_tag);
				$this_tag= str_replace("%email-to-name%", $emailtoname, $this_tag);


				$output.=$this_tag;
				$last_comment=$temp_row["ip"].$temp_row["comment"];

			}
		}
	}

	// make an array of strings with the notices to print
	$text = array($Weblogs[$Current_weblog]['comments_text_0'], $Weblogs[$Current_weblog]['comments_text_1'], $Weblogs[$Current_weblog]['comments_text_2']);

	//$comm_ind = sprintf("<p style=\"clear:both;\"><b>%s:</b></p>", $text[min(2,count($db->entry['comments']))]);	
	$comm_ind = sprintf("<p><b>%s:</b></p>", $text[min(2,count($db->entry['comments']))]);	
	$comm_ind = str_replace("%num%", lang('numbers', count($db->entry['comments'])), $comm_ind);
	$comm_ind = str_replace("%n%", count($db->entry['comments']), $comm_ind);
	$output = $comm_ind . $output;

	return $output;
}

// get archive name for a certain entry. Used to make permalinks
function make_archive_name($date="", $this_weblog="") {
	global $db, $Cfg, $Weblogs, $Current_weblog;

	if ($date=="") { 
		if (isset($db->entry)) {
			$date = $db->entry['date']; 
		} else {
			$date = date("Y-m-d-H-i");
		}
	}
	

	$year = format_date($date, "%year%");

	if ($this_weblog=="") {
		$this_weblog = $Weblogs[$Current_weblog];
	} else {
		$this_weblog = $Weblogs[$this_weblog];
	}

	$archive_num= ($this_weblog['archive_unit']=="week") ? format_date($date, "%weeknum%") : format_date($date, "%month%");
	$archive_type= ($this_weblog['archive_unit']=="week") ? "w" : "m";
	$archive_name=sprintf("%s-%s%s", $year, $archive_type, $archive_num);
	$archive_name=str_replace("%1",$archive_name,$this_weblog['archive_filename']);


	return $archive_name;
}

function make_archive_link($date="") {
	global $db, $base_url, $Weblogs, $Current_weblog;

	if ($date=="") { $date = $db->entry['date']; }

	$filelink = $base_url . $Weblogs[$Current_weblog]['archive_path'] . make_archive_name($date);
	$filelink = fixPath($filelink);

	return $filelink;

}


function make_archive_array($force=FALSE) {
	global $Archive_array, $db;
			
	$arc_db = new db();

	$Archive_array = $arc_db->get_archive_array();

}


function make_filename($code="", $weblog="", $anchor="comm", $parameter="") {
	global $db, $Paths, $Weblogs, $Current_weblog;

	if ($code=="") { $code = $db->entry['code']; }
	if ($weblog=="") { $weblog=$Current_weblog; }

	$filename =  $Weblogs[$weblog]['entry_path'] . $Weblogs[$weblog]['entry_filename'];
	$filename = str_replace("%1", $code, $filename);
	$filename = format_date("", $filename);

	return $filename;

}

function make_filelink($code="", $weblog="", $anchor="comm", $parameter="", $para_weblog=FALSE) {
	global $db, $Weblogs, $Current_weblog, $Cfg, $temp_entry, $Paths;

	if ($code=="") { $code = $db->entry['code']; }
	if ($weblog=="") { $weblog=$Current_weblog; }

	// for non-crufty urls
	if (!isset($temp_entry) || (!is_array($temp_entry)) ) { @$temp_entry = $db->entry; }

	if (!$Weblogs[$weblog]['live_entries']) {
		$filelink = $Paths['pivot_url'] . $Weblogs[$Current_weblog]['entry_path'] . $Weblogs[$Current_weblog]['entry_filename'];
	} else if ( (isset($Cfg['mod_rewrite'])) && ($Cfg['mod_rewrite']==1) && ($temp_entry['date']!="") ) {
		// if $temp_entry['date'] is not set, we cant make the non-crufty url, 
		// and we fall back to the crufty one..

		list($yr,$mo,$da,$ho,$mi)=split("-",$temp_entry['date']);
		
		$name = (strlen($temp_entry['title'])>2) ? $temp_entry['title'] : substr($temp_entry['introduction'],0,100);
		$name = safe_string($name, TRUE);
				
		if (strlen($name)>30) { $name = substr($name, 0, 30); }

		$filelink = $Paths['log_url'] . "/archive/$yr/$mo/$da/".$name;
	} else {
		$filelink = $Paths['pivot_url'] . "entry.php?id=%1$parameter";
		if ($para_weblog) { $filelink .= "&w=".$Current_weblog; }
	}

	$temp_entry = "";

	$filelink = fixPath($filelink);
	$filelink = str_replace("%1", $code, $filelink);
	$filelink = format_date("", $filelink);

	if ($anchor != "") {
		$filelink .= "#".$anchor;
	}

	return $filelink;

}

function make_fileurl($code="", $weblog="", $anchor="comm", $parameter="") {
	global $HTTP_SERVER_VARS;

	$link = make_filelink($code, $weblog, $anchor, $parameter);

	return "http://".$HTTP_SERVER_VARS['HTTP_HOST'].$link;

}

// =============================================
// the functions below are used for outputting 
// the weblog as RSS.
// =============================================

function rss_offset() {

	$z=date("Z");

	if (!is_numeric($z)) { $z = 0; }

	$offset = ( ($z>0) ? "+" : "-" ) . sprintf("%02d:%02d", floor(abs($z) / 3600), floor($z % 3600)/60);

	return $offset;

}

function start_rss() {
	global $rss, $rss_items, $atom, $atom_items, $db, $HTTP_SERVER_VARS, $build, $Current_user, $Weblogs, $Current_weblog, $Paths, $Users, $Cfg;

	$link= gethost() . fixPath($Paths['pivot_url'] . $Weblogs[$Current_weblog]['front_path'] . $Weblogs[$Current_weblog]['front_filename']);

	$charset = snippet_charset();

	$rss_preamble='<?xml version="1.0" encoding="%charset%"?'.'>
	<rss version="2.0" 
		xmlns:dc="http://purl.org/dc/elements/1.1/"
		xmlns:sy="http://purl.org/rss/1.0/modules/syndication/"
		xmlns:admin="http://webns.net/mvcb/"
		xmlns:rdf="http://www.w3.org/1999/02/22-rdf-syntax-ns#"
		xmlns:content="http://purl.org/rss/1.0/modules/content/">

	<channel>
		<title>%title%</title>
		<link>%link%</link>
		<description>%description%</description>
		<dc:language>en-us</dc:language>
		<dc:creator>%author%</dc:creator>
		<dc:rights>Copyright %year%</dc:rights>
		<dc:date>%date%</dc:date>
		<admin:generatorAgent rdf:resource="%genagent%" />
		<admin:errorReportsTo rdf:resource="mailto:rsserrors@pivotlog.net"/>
		<sy:updatePeriod>hourly</sy:updatePeriod>
		<sy:updateFrequency>1</sy:updateFrequency>
		<sy:updateBase>2000-01-01T12:00+00:00</sy:updateBase>';


	$atom_preamble='<?xml version="1.0" encoding="%charset%"?'.'>
<feed version="0.3"
  xmlns="http://purl.org/atom/ns#"
  xmlns:dc="http://purl.org/dc/elements/1.1/"
  xml:lang="%lang%">
  <title>%title%</title>
  <link rel="alternate" type="text/html" href="%link%"/>
  <modified>%date%</modified>
  <author>
    <name>%admin-nick%</name>
    <url>%link%</url>
    <email>%admin-email%</email>
  </author>
  <tagline>%description%</tagline>
  <id>tag:%sitename_safe%,%year%:%title_safe%</id>
  <generator url="http://www.pivotlog.net" version="%version%">Pivot</generator>
  <copyright>Copyright (c) %year%, Authors of %title%</copyright>
';

	
	reset($Users);
	$user = each($Users);
	$user = $user['value'];


	$from = array(
		"%sitename%",
		"%title%",
		"%sitename_safe%",
		"%title_safe%",
		"%link%",
		"%description%",
		"%author%",
		"%admin-email%",
		"%admin-nick%",
		"%year%",
		"%date%",
		"%genagent%",
		"%version%",
		"%lang%",
		"%charset%",
	);

	$to = array(
		$Cfg['sitename'],
		str_replace("&", "&amp;", $Weblogs[$Current_weblog]['name']),
		str_replace("_", "", safe_string($Cfg['sitename'], TRUE)),
		str_replace("_", "", safe_string($Weblogs[$Current_weblog]['name'], TRUE)),
		$link, 
		$Weblogs[$Current_weblog]['payoff'], 
		$Current_user,
		$user['email'],
    $user['nick'],
		date("Y"),
		date("Y-m-d\TH:i:s").rss_offset(), 
		"http://www.pivotlog.net/?ver=".urlencode($build),
		urlencode($build),
		$Cfg['deflang'],
		$charset,
	);


	$rss= str_replace($from, $to, $rss_preamble);
	$atom= str_replace($from, $to, $atom_preamble);

	$rss_items = array();
	$atom_items = array();
	

}

function add_rss($uid, $date, $title, $introduction, $body, $user, $category) {
	global $db, $rss_items, $atom_items, $Cfg, $HTTP_SERVER_VARS, $base_url, $Weblogs, $Current_weblog, $Allow_RSS, $Paths;

	if (!$Allow_RSS) { return; }

	$link = make_fileurl($uid, "", "");
	$weblog = gethost() . fixPath($Paths['pivot_url'] . $Weblogs[$Current_weblog]['entry_path']);

	$title = $db->entry['title'];
	
	// parse fields and remove scripting from the feed. Script in feed is bad..
	$introduction = parse_intro_or_body( $db->entry['introduction'] );
	$introduction = preg_replace('/(onclick="[^"]*")/Ui', "", $introduction);
	$introduction = preg_replace("/(onclick='[^']*')/Ui", "", $introduction);
	
	$body = parse_intro_or_body( $db->entry['body'] );
	$body = preg_replace('/(onclick="[^"]*")/Ui', "", $body);
	$body = preg_replace("/(onclick='[^']*')/Ui", "", $body);

	$tag = 	str_replace("_", "",  safe_string($Cfg['sitename'], TRUE)) . ",". date("Y") . ":" . 
		str_replace("_", "",  safe_string($Weblogs[$Current_weblog]['name'], TRUE))."." . $uid;
	
	$lang = snippet_lang();

	$date = format_date( $date, "%year%-%month%-%day%T%hour24%:%minute%:00").rss_offset();
	
	$description = htmlspecialchars(strip_tags($introduction));
	$description = str_replace("&nbsp;"," ", $description);	
	
	// make sure description is not too long..
	if ( (isset($Weblogs[$Current_weblog]['rss_full'])) && ($Weblogs[$Current_weblog]['rss_full']==0) ) {
		// don't put anything in the content.
		$content="";
	} else {
		// put the introduction and body in the content..
		$content = str_replace("&nbsp;"," ", ($introduction.$body));	
	}



	$rss_item='
	<item>
		<title>%title%</title>
		<link>%link%</link>
		<comments>%link%#comm</comments>
		<description>%description%</description>
		<guid isPermaLink="false">%guid%</guid>
		'. ($content=="" ? "" : "<content:encoded><![CDATA[ %content% ]]></content:encoded>") .'
		<dc:subject>%category%</dc:subject>
		<dc:date>%date%</dc:date>
    </item>
';

	$atom_item='<entry>
    <title>%title%</title>
    <link rel="alternate" type="text/html" href="%link%"/>
    <modified>%date%</modified>
    <issued>%date%</issued>
    <id>tag:%tag%</id>

    <created>%date%</created>
    <summary type="text/plain">%description%</summary>
    <dc:subject>%title%</dc:subject>
		<author>
		 <name>%author%</name>
	  </author>
	  '. ($content=="" ? "" : '<content type="text/html" mode="escaped" xml:lang="%lang%" xml:base="%link%"><![CDATA[ %content% ]]></content>') .'
  </entry>
';


	$from = array(
		"%title%", 
		"%link%", 
		"%description%", 
		"%author%",
		"%guid%", 
		"%date%", 
		"%category%", 
		"%content%", 
		"%tag%",
		"%lang%",
	);

	$to = array(
		htmlspecialchars(strip_tags($title)), 
		$link, 
		RelativeToAbsoluteURLS($description), 
		$user, 
		$uid."@".$weblog, 
		$date, 
		implode(", ",$category), 
		RelativeToAbsoluteURLS($content), 
		$tag,
		$lang,
	);

	$rss_item= str_replace($from, $to, $rss_item);
	$atom_item= str_replace($from, $to, $atom_item);

	$rss_items[$date]=$rss_item;
	$atom_items[$date]=$atom_item;


}

function finish_rss() {
	global $rss, $rss_items, $atom, $atom_items, $global_pref, $Weblogs, $Current_weblog, $VerboseGenerate;

	// sort the items..
	ksort($rss_items);
	$rss_items= array_reverse($rss_items);

	ksort($atom_items);
	$atom_items= array_reverse($atom_items);

	
	//write out the rss
	if($Weblogs[$Current_weblog]['rss_filename'] != "") {
			
		foreach ($rss_items as $item) {
			$rss .= $item;
		}

		$rss.="\n</channel>\n</rss>";

		$filename = $Weblogs[$Current_weblog]['rss_path'] . $Weblogs[$Current_weblog]['rss_filename'];

		add_log("Write RSS: $filename");

		//make sure the directory exists
		makedir($Weblogs[$Current_weblog]['rss_path']);

		write_file($filename, $rss);

	}


	//write out the atom feed
	if($Weblogs[$Current_weblog]['atom_filename'] != "") {
			
		foreach ($atom_items as $item) {
			$atom .= $item;
		}

		$atom.="\n</feed>\n";

		$filename = $Weblogs[$Current_weblog]['rss_path'] . $Weblogs[$Current_weblog]['atom_filename'];

		add_log("Write Atom: $filename");

		write_file($filename, $atom); 


	}

}


?>