<?php

// ---------------------------------------------------------------------------
//
// PIVOT - LICENSE:
//
// This file is part of Pivot. Pivot and all its parts are licensed under 
// the GPL version 2. see: http://www.pivotlog.net/help/help_about_gpl.php
// for more information.
//
// ---------------------------------------------------------------------------


//------------------------------------------
// These are the standard snippets..
//------------------------------------------

// include a file
function snippet_include($filename) {
	global $Cfg;

	$org_filename= $filename;

	if (!file_exists($filename)) {
		$filename="templates/".$org_filename;
	}

	if (!file_exists($filename)) {
		$filename="../".$org_filename;
	}


	if (file_exists($filename)) {
		$file=parse_step4(implode("", file("$filename")));
	} else {
		if ($Cfg['debug']==0) {
			$file="<!-- error: could not include $org_filename. File does not exist -->";
		} else {
			$file="[error: could not include $org_filename. File does not exist]";
		}
	}

	return $file;

}


// insert an image
function snippet_image ($filename, $alt="", $align="", $border=0) {
	global $Cfg, $Paths;
	
	if ( ($border=="") || (!is_numeric($border)) ) { $border=0; }

	$org_filename = $filename;

	if (!file_exists("../".$filename)) {
		$filename = "../".$Cfg['upload_path'].$filename;
	} else {
		$filename = "../".$filename;
	}
	
	if (file_exists($filename)) {

		$filename = fixpath($Paths['pivot_url'].$filename);

		if ($align=="left") {
			$code="<img src=\"$filename\" style='margin-right:10px; margin-bottom:5px;' border=\"$border\" title=\"$alt\" alt=\"$alt\" align=\"left\" />";
		} else if ($align=="right") {
			$code="<img src=\"$filename\" style='margin-left:10px; margin-bottom:5px;' border=\"$border\"  title=\"$alt\" alt=\"$alt\" align=\"right\" />";
		} else if ($align=="inline") {
			$code="<img src=\"$filename\" border=\"$border\" title=\"$alt\" alt=\"$alt\" />";
		} else {
			$code="<p style=\"text-align:center;\"><img src=\"$filename\" border=\"$border\" title=\"$alt\" alt=\"$alt\" /></p>";
		}  
		
		
	} else {
		$code="<!-- error: could not display image $org_filename. File does not exist -->";
	}

	return $code;

}



// insert a popup to an image
function snippet_popup ($filename, $thumbname,  $alt="", $align="center", $border="") {
	global	$Cfg, $Paths;
	
	if (is_numeric($align)) {
		// the border and align properties were swapped, so we need
		// to compensate for the wrong ones.
		$i = $border;
		$border = $align;
		$align = $i;
	}

	if ( ($border=="") || (!is_numeric($border)) ) { $border=1; }

	$border= set_target("style=\"border: ".$border."px solid;\"", "border=\"$border\"");

	// Fix filename, if necessary
	$org_filename = $filename;

	if (!file_exists("../".$filename)) {
		$filename = "../".$Cfg['upload_path'].$filename;
	} else {
		$filename = "../".$filename;
	}
	
	// Fix Thumbname, perhaps use a thumbname, instead of textual link
	$org_thumbname = $thumbname;
	if ( ($thumbname=="") || ($thumbname=="(thumbnail)") ) {
		$ext = getextension($org_filename);
		$thumbname = str_replace($ext, 'thumb.'.$ext, $org_filename);
	}
	if (!file_exists("../".$thumbname)) {
		$thumbname = "../".$Cfg['upload_path'].$thumbname;
	} else {
		$thumbname = "../".$thumbname;
	}
	
	// If the thumbnail exists, make the HTML for it, else just use the text for a link.
	if (file_exists($thumbname)) {
		$thumbname = $Paths['host'] . fixpath( $Paths['pivot_url'].$thumbname);

		$ext=getextension($thumbname);
		if ( ($ext=="jpg")||($ext=="gif")||($ext=="png") ) {
				if ($align=="center") {
					$thumbname="<img src=\"$thumbname\" $border alt=\"$alt\" title=\"$alt\" />";
				} else {
					$thumbname="<img src=\"$thumbname\" $border alt=\"$alt\" title=\"$alt\" align=\"$align\" />";
				}
		} else {
			$thumbname = $org_thumbname;
		}
	} else {
		if (strlen($org_thumbname)>2) {
			$thumbname = $org_thumbname;
		} else {
			$thumbname = "popup";
		}
	}

	// Finally, make the HTML for the popup..
	if (file_exists($filename)) {
		list($width,$height)=GetImageSize($filename);

		$filename = $Paths['host'] . fixpath( $Paths['pivot_url']. $filename);

		$url=$Paths['host'] . sprintf($Paths['pivot_url']."includes/photo.php?img=%s&amp;w=%s&amp;h=%s&amp;t=%s",$filename, $width, $height, $alt); 

		$target = set_target('', 'target="_self"');
		// removed the onmouseover=\"window.status='(popup)';return true;\" 
		// and onmouseout=\"window.status='';return true;\"
		// that is _so_ 2002..
		$code = sprintf("<a href='$filename'  onclick=\"window.open('%s','imagewindow','width=%s,height=%s,directories=no,location=no,menubar=no,scrollbars=no,status=no,toolbar=no,resizable=no,left=0,top=0');return false\" style='border: 0;' %s>%s</a>", $url, $width, $height, $target, $thumbname);


		if ($align=="center") {
			$code="<p style=\"text-align:center;\">$code</p>";
		}

	} else {
		$code="[!-- error: could not popup $filename. File does not exist --]";
	}


	return $code;
}

// link to a file
function snippet_link ($filename, $name) {
	
	$ext=getextension($filename);

	if ( ($ext=="doc")||($ext=="pdf")||($ext=="txt")||($ext=="ppt")||($ext=="pot")||($ext=="xls")||($ext=="mdb") ) {
		$target = set_target(' rel="external"', ' target="_blank"');
	} else {
		$target="";
	}
	if (file_exists("../".$filename)) {
		$code = "<a href=\"$filename\" $target>$name</a>";
	} else {
		$code="<!-- error: could not link to $filename. File does not exist -->";
	}

	return $code;
}


// make something lowercase
function snippet_lower($text) {
	return strtolower($text);
}


// make something uppercase
function snippet_upper($text) {
	return strtoupper($text);
}


function snippet_weblogtitle() {
	global $Weblogs, $Current_weblog;

	$output=$Weblogs[$Current_weblog]['name'];
	return $output;
}


function snippet_weblogsubtitle() {
	global $db, $Weblogs, $Current_weblog;

	$output=$Weblogs[$Current_weblog]['payoff'];
	return $output;
}


function snippet_weblogname() {
	global $Weblogs, $Current_weblog;

	$output=$Current_weblog;
	return $output;
}


function snippet_archivetitle() {
	global $db, $Weblogs, $Current_weblog;

	$output=$Weblogs[$Current_weblog]['name'];
	return $output;
}


function snippet_archivesubtitle() {
	global $db, $Weblogs, $Current_weblog;

	$output=$Weblogs[$Current_weblog]['payoff'];
	return $output;
}


function snippet_link_list() {

	if(file_exists('templates/link_list.html')) {
		$output = snippet_include('link_list.html');
	} else {
		$output = snippet_include('_aux_link_list.html');
	}
	
	$output = targetblank($output);

	return $output;

}


function snippet_archive_list() {
	global $Weblogs, $Current_weblog, $Archive_array, $Archive_array_html , $Paths;

	if ($Weblogs[$Current_weblog]['archive_unit']=="none") {
		// if no archives are needed, just return.
		return "";
	}

	// if not yet done, load / make the array of archive filenames (together
	// with at least one date)
	if (!isset($Archive_array)) { make_archive_array(); }

	// if not yet done, compile the html for this archive list
	if (!isset($Archive_array_html[$Current_weblog])) {

		$output = "";

		// maybe flip and reverse it.
		if($Weblogs[$Current_weblog]['archive_order'] == 'descending') {
			$Archive_array[$Current_weblog] = array_reverse($Archive_array[$Current_weblog]);
		}

		foreach($Archive_array[$Current_weblog] as $file => $date) {


			// make Mark proud, and make a nice absolute url for the archive..
			$filelink = $Paths['pivot_url'] . $Weblogs[$Current_weblog]['archive_path'] . $file;
			$filelink = fixPath($filelink);

			// fix the rest of the string..
			list($start_date, $stop_date) = getdaterange($date, $Weblogs[$Current_weblog]['archive_unit']);
			$this_output = format_date_range($start_date, $stop_date, $Weblogs[$Current_weblog]['archive_linkfile']);

			$this_output = str_replace("%url%" , $filelink, $this_output);

			$output .= $this_output;

		}

		// store it for quick access later on..
		$Archive_array_html[$Current_weblog] = $output;

	} else {

		// goodie, it's alread been done, so we just retrieve it.
		$output = $Archive_array_html[$Current_weblog];

	}

	return stripslashes($output);

}


function snippet_subweblog ($sub="", $count="") {
	global $db;

	if ($sub!="") { $sub="subweblog=\"$sub\""; }
	if ($count!="") { $count="showme=\"$count\""; }

	$output= cms_tag_weblog("nodes=\"lower\" order=\"lasttofirst\" $sub $count",'');
	
	return $output;
}

// an alias for [[subweblog]]
function snippet_weblog ($sub="", $count="") {

// if no subweblog has been specified, just assume 'standard'
	if (strlen($sub)<2) { $sub = "standard"; }

	return snippet_subweblog($sub, $count);

}



function snippet_archive ($sub="") {

	if ($sub!="") { $sub="subweblog=\"$sub\""; }

	$output= cms_tag_archive("nodes=\"lower\" order=\"lasttofirst\" $sub",'');

	return $output;
}

function snippet_pivotbutton() {
	global $Paths, $build;

	// Hack by digits to adjust image size if custom Pivot image is used
	list($width, $height) = getimagesize($Paths['pivot_path'].'pics/pivotbutton.png');
	$image = $Paths['pivot_url']."pics/pivotbutton.png";
	$output =  '<a href="http://www.pivotlog.net/?ver='.urlencode($build).'" title="Powered by '.$build.'"><img src="'.$image.'" width="'.$width.'" height="'.$height.'" alt="Powered by Pivot" style="border:0;" /></a> ';
	// End hack 


	$output = targetblank($output);
	
	return $output;

}

function snippet_code() {
	global $db;

	$output=$db->entry['code'];
	
	return $output;
}


function snippet_uid() {
	global $db;

	$output=$db->entry['code'];

	return $output;
}


function snippet_id_anchor() {
	global $db;

	$output="<span id=\"e".$db->entry['code']."\"></span>";

	return $output;
}

function snippet_title() {
	global $db;

	$output = $db->entry['title'];

	return $output;
}



function snippet_subtitle() {
	global $db;

	$output=$db->entry['subtitle'];


	return $output;
}


function snippet_introduction($strip="") {
	global $db, $Weblogs, $Current_weblog;

	$output = parse_intro_or_body( $db->entry['introduction'], $strip);

	return $output;

}


function snippet_body($strip="") {
	global $db, $Weblogs, $Current_weblog;

	$output = parse_intro_or_body( $db->entry['body'], $strip);
	
	return $output;

}


function snippet_date($format="") {
	global $db, $Weblogs, $Current_weblog;

	if($format=="") {
		$format = $Weblogs[$Current_weblog]['entrydate_format'];
	} else {
		// compensate for textile oddness..
		$format = str_replace("<span>", "%", $format);
		$format = str_replace("</span>", "%", $format);
	}

	$output=format_date($db->entry["date"], $format );	

	return $output;
}


function snippet_fulldate($format="") {
	global $db, $Weblogs, $Current_weblog;

	if($format=="") {
		$format = $Weblogs[$Current_weblog]['fulldate_format'];
	} else {
		// compensate for textile oddness..
		$format = str_replace("<span>", "%", $format);
		$format = str_replace("</span>", "%", $format);
	}

	$output=format_date($db->entry["date"], $format );


	return $output;
}



function snippet_diffdate() {
	global $db, $diffdate_thisformat, $diffdate_lastformat, $Weblogs, $Current_weblog;

	$diffdate_thisformat=format_date($db->entry["date"], $Weblogs[$Current_weblog]['diffdate_format'] );
	if ( (!isset($diffdate_lastformat)) || ($diffdate_lastformat!=$diffdate_thisformat) ) {
		$diffdate_lastformat=$diffdate_thisformat;
	} else {
		$diffdate_thisformat="";
	}


	return $diffdate_thisformat;
}



function snippet_cookie($name="") {
	global $Pivot_Vars, $Pivot_Cookies, $Weblogs, $Current_weblog;

	// if we don't use live entries, do _not_ use the cookies..
	if ($Weblogs[$Current_weblog]['live_entries'] == 0) {
		return "";
	}


	// get the cookies in an array..
	if (isset($Pivot_Vars['HTTP_COOKIE']) && !isset($Pivot_Cookies))  {
		foreach (explode(";", $Pivot_Vars['HTTP_COOKIE']) as $cookie) {
			list ($key, $value)= explode("=", $cookie);
			$Pivot_Cookies[trim($key)] = urldecode(trim($value));
		}
	}

	switch($name) {
		case 'all': 
			echo "<h1>koekies</h1><pre>cookies:";
			print_r($Pivot_Cookies);
			echo "</pre>";
			break;
		case 'name':
			return (isset($Pivot_Cookies['piv_name'])) ? $Pivot_Cookies['piv_name'] : "";
			break;
		case 'email':
			return (isset($Pivot_Cookies['piv_email'])) ? $Pivot_Cookies['piv_email'] : "";
			break;
		case 'url':
			return (isset($Pivot_Cookies['piv_url'])) ? $Pivot_Cookies['piv_url'] : "";
			break;
		case 'remember_yes':
			return (isset($Pivot_Cookies['piv_rememberinfo'])) ? "checked='checked'" : "";
			break;
		case 'remember_no':
			return (isset($Pivot_Cookies['piv_rememberinfo'])) ? "" : "checked='checked'";
			break;
	}
	

}


function snippet_jscookies() {

	$output = "<script type='text/javascript'>
//<![CDATA[
function readCookie(name) { var cookieValue = ''; var search = name + '='; if(document.cookie.length > 0) {  offset = document.cookie.indexOf(search); if (offset != -1) {  offset += search.length; end =  document.cookie.indexOf(';', offset); if (end == -1) end = document.cookie.length; cookieValue = unescape(document.cookie.substring(offset, end)) } } return cookieValue.replace(/\+/gi, ' '); } function getNames() { if (document.getElementsByName('piv_name')) { elt = document.getElementsByName('piv_name'); elt[0].value=readCookie('piv_name'); } if (document.getElementsByName('piv_email')) { elt = document.getElementsByName('piv_email'); elt[0].value=readCookie('piv_email');  } if (document.getElementsByName('piv_url')) { elt = document.getElementsByName('piv_url'); elt[0].value=readCookie('piv_url');  } if (document.getElementsByName('piv_rememberinfo')) { elt = document.getElementsByName('piv_rememberinfo'); if (readCookie('piv_rememberinfo') == 'yes') { elt[0].checked = true; } } } window.onload = setTimeout('getNames()', 500);
//]]>
</script>";

	return $output;

}

function snippet_nick() {
	return snippet_user("nick");
}


function snippet_user($field) {
	global $db, $Users;

	if ($field=="") {

		$output=$db->entry['user'];

	} else if ($field=="emailtonick") {
		
		if ($Users[$db->entry['user']]['nick']!="") {
			$output = encodemail_link($Users[$db->entry['user']]['email'], $Users[$db->entry['user']]['nick'] );
		} else {
			$output = encodemail_link($Users[$db->entry['user']]['email'], $db->entry['user']);
		}

	} else {

		$output = $Users[$db->entry['user']][$field];

	}
	

	return $output;
}


function snippet_category($filter="") {
	global $db, $Weblogs, $Current_weblog, $Current_subweblog;

	$output=$db->entry["category"];

	if ( ($filter != "") && (isset($Weblogs[$Current_weblog]['sub_weblog'][$Current_subweblog])) ) {
		$output = array_intersect ( $Weblogs[$Current_weblog]['sub_weblog'][$Current_subweblog]['categories'], $output);
	}

	if (is_array($output)) {
		return implode(", ", $output);
	} else {
		return "";
	}
}

// for backwards compatibility
function snippet_email() {
	global $db, $Users;

	if ($db->entry['code']=='ROOT') {
		$output='<cms email></cms>';
	} else {
		$output=encodemail($Users[$entry['user']]['email']);
	}

	return $output;
}

// for backwards compatibility
function snippet_email_to_nick() {
	global $db, $Users;

	if ($db->entry['code']=='ROOT') {
		$output='<cms emailtonick></cms>';
	} else {
		if (isset($Users[$db->entry['user']])) {
			$output = encodemail_link($Users[$db->entry['user']]['email'], $db->entry['user']);
		} else {
			$output = $db->entry['user'];
		}
	}


	return $output;
}




function snippet_more() {
	global $db, $Weblogs, $Current_weblog, $Cfg;

	if (strlen($db->entry['body'])>5) {

		$morelink=make_filelink($db->entry['code'], "", "body");

		$text= ( strlen($Weblogs[$Current_weblog]['read_more']) > 1 ) ? $Weblogs[$Current_weblog]['read_more'] : "(more)";	

		if ($Weblogs[$Current_weblog]['comment_pop']==1) {

			$target = set_target('', 'target="_self"');


			$output = sprintf("<a href='%s' ", $morelink);
			$output.= sprintf("onclick=\"window.open('%s', 'popuplink', 'width=%s,height=%s,directories=no,location=no,scrollbars=yes,menubar=no,status=yes,toolbar=no,resizable=yes'); return false\"", $morelink, $Weblogs[$Current_weblog]['comment_width'], $Weblogs[$Current_weblog]['comment_height']);
			$output.= sprintf(" %s>%s</a>", $target, $text);
	
		} else {
				$output = "<a href=\"$morelink\">".$Weblogs[$Current_weblog]['read_more']."</a>";
		}
			

	} else {
		$output="";
	}

	return $output;

}


function snippet_comments() {
	global $db;
	
	$output = cms_tag_comments('', '');
	
	return $output;
}


function snippet_commentform() {
	global $Cfg, $HTTP_SERVER_VARS, $db, $Weblogs, $Current_weblog;
	
	// check for entry's allow_comments, blocked IP address or subweblog comments..
	if ( (isset($db->entry['allow_comments']) && ($db->entry['allow_comments']==0)) || (ip_check_block($HTTP_SERVER_VARS['REMOTE_ADDR']))  ) {
		// if allow_comments set to 0, or current visitor has his ip blocked, then don't show form
		$output ="";
	}	else {
		// else show it
		if(file_exists('templates/_sub_commentform.html')) {
			$output='[[include:templates/_sub_commentform.html]]';
		} else {
			$output='[[include:templates/commentform.html]]';
		}
		
		$output = parse_step4($output);

	}

	return $output;
	
}


function snippet_archivenext($text="") {
	global $db, $Weblogs, $Current_weblog, $Archive_array, $archive_array_next;

	if (!isset($db->entry)) { return ""; }

	// get the filename for the current archive..
	$current_archive = make_archive_name();
	$id = $db->entry['code'];

	// if we did this one before, it's easy. just return it.
	if (isset($archive_array_next[ $Current_weblog.$current_archive ])) {
		return $archive_array_next[ $Current_weblog.$current_archive ];
	}

	// get the archive_array, if it's not done yet.
	if (!isset($Archive_array)) { make_archive_array(); }

	// we make another array where we number the archives. As far as i know this is
	// the only decent way to find the next or previous entries..
	// sometime i will want to cache this for performance
	$counter = 0;
	foreach ($Archive_array[$Current_weblog] as $this_key => $this_val) {
		$temp_arr[$counter] = $this_key;
		if ($this_key == $current_archive) { $this_count = $counter; }
		$counter++;
	}

	if($text=="") {
		$text = lang('weblog_text','next_archive');
	}

	// then, we'll pick out the previous one in the array (remember, the array
	// is in reverse chronological order)
	if (isset($temp_arr[$this_count+1])) {
		$next_arc = $temp_arr[$this_count+1];
		$target = set_target('', 'target="_self"');

		$link = make_archive_link($Archive_array[$Current_weblog][ $next_arc ]);
		$link = sprintf("<a href=\"%s\" %s>%s</a>", $link, $target, $text ) ;
		$archive_array_next[ $Current_weblog.$current_archive ] = $link;

		return $link;
	} else {
		$archive_array_next[ $Current_weblog.$current_archive ] = "";
		return "";

	}

}



function snippet_archiveprevious($text="") {
	global $db, $Weblogs, $Current_weblog, $Archive_array, $archive_array_prev;

	if (!isset($db->entry)) { return ""; }

	// get the filename for the current archive..
	$current_archive = make_archive_name();
	$id = $db->entry['code'];

	// if we did this one before, it's easy. just return it.
	if (isset($archive_array_prev[ $Current_weblog.$current_archive ])) {
		return $archive_array_prev[ $Current_weblog.$current_archive ];
	}

	// get the archive_array, if it's not done yet.
	if (!isset($Archive_array)) { make_archive_array(); }

	// we make another array where we number the archives. As far as i know this is
	// the only decent way to find the next or previous entries..
	// sometime i will want to cache this for performance
	$counter = 0;
	foreach ($Archive_array[$Current_weblog] as $this_key => $this_val) {
		$temp_arr[$counter] = $this_key;
		if ($this_key == $current_archive) { $this_count = $counter; }
		$counter++;
	}

	if($text=="") {
		$text = lang('weblog_text','next_archive');
	}

	// then, we'll pick out the next one in the array (remember, the array
	// is in reverse chronological order)
	if (isset($temp_arr[$this_count-1])) {
		$prev_arc = $temp_arr[$this_count-1];
		$target = set_target('', 'target="_self"');

		$link = make_archive_link($Archive_array[$Current_weblog][ $prev_arc ]);
		$link = sprintf("<a href=\"%s\" %s>%s</a>", $link, $target, lang('weblog_text','previous_archive') ) ;
		$archive_array_prev[ $Current_weblog.$current_archive ] = $link;

		return $link;
	} else {
		$archive_array_prev[ $Current_weblog.$current_archive ] = "";
		return "";

	}

}



function snippet_nextentry($text="", $cutoff) {
	global $db, $global_pref, $temp_entry;

	// initialize a temporary db..
	$temp_db = new db(FALSE);
	
	// we fetch the next one, until we get one that is set to 'publish'
	$get_next_amount = 1;
	do {
		$next_code=$db->get_next_code($get_next_amount);
		if ($next_code) { $temp_entry = $temp_db->read_entry($next_code); }
		$get_next_amount++;
	} while ( !($next_code===FALSE) && !($temp_entry['status']=="publish") );

	unset($temp_db);

	if ($text=="") {
		$text="&nbsp;&nbsp;&raquo; <a href='%link%'>%title%</a>";
	}
	
	if ($cutoff=="") {
		$cutoff=20;
	}

	if ($next_code) {
		$title= (strlen($temp_entry['title'])>2) ? $temp_entry['title'] : substr($temp_entry['introduction'],0,100);
		$link=make_filelink($next_code, "", "");
		$output="$text";
		$output=str_replace("%link%", $link, $output);
		$output=str_replace("%code%", $next_code, $output);
		$output=str_replace("%title%", trimtext($title,$cutoff), $output);
		return $output;

	} else {
		return "";
	}

}



function snippet_previousentry($text="", $cutoff) {
	global $db, $global_pref, $temp_entry;

	// initialize a temporary db..
	$temp_db = new db(FALSE);
	
	// we fetch the next one, until we get one that is set to 'publish'
	$get_prev_amount = 1;
	do {
		$prev_code=$db->get_previous_code($get_prev_amount);
		if ($prev_code) { $temp_entry = $temp_db->read_entry($prev_code); }
		$get_prev_amount++;
	} while ( !($prev_code===FALSE) && !($temp_entry['status']=="publish") );

	unset($temp_db);

	if ($text=="") {
		$text=(isset($Cfg['entrynext'])) ? $global_pref['entrynext'] : "&laquo; <a href='%link%'>%title%</a>";
	}
	if ($cutoff=="") {
		$cutoff=20;
	}

	if ($prev_code) {
		$title= (strlen($temp_entry['title'])>2) ? $temp_entry['title'] : substr($temp_entry['introduction'],0,100);
		$link=make_filelink($prev_code, "", "");
		$output="$text";
		$output=str_replace("%link%", $link, $output);
		$output=str_replace("%code%", $prev_code, $output);
		$output=str_replace("%title%", trimtext($title,$cutoff), $output);
		return $output;
	} else {
		return "";
	}
}



function snippet_nextentryincategory($text="", $cutoff) {
	global $db, $global_pref, $temp_entry;

	// initialize a temporary db..
	$temp_db = new db(FALSE);
	
	$cat = $db->entry['category'];

	// we fetch the next one, until we get one that is set to 'publish'
	$get_next_amount = 1;
	do {
		$next_code=$db->get_next_code($get_next_amount);
		if ($next_code) { $temp_entry = $temp_db->read_entry($next_code); }
		$get_next_amount++;
	
		if ($next_code===FALSE) { break; }

	} while (  !($temp_entry['status']=="publish")  || (count(@array_intersect( $temp_entry['category'], $cat)) == 0) );

	unset($temp_db);

	if ($text=="") {
		$text="&nbsp;&nbsp;&raquo; <a href='%link%'>%title%</a>";
	}
	
	if ($cutoff=="") {
		$cutoff=20;
	}

	if ($next_code) {
		$title= (strlen($temp_entry['title'])>2) ? $temp_entry['title'] : substr($temp_entry['introduction'],0,100);
		$link=make_filelink($next_code, "", "");
		$output="$text";
		$output=str_replace("%link%", $link, $output);
		$output=str_replace("%code%", $next_code, $output);
		$output=str_replace("%title%", trimtext($title,$cutoff), $output);
		return $output;

	} else {
		return "";
	}

}



function snippet_previousentryincategory($text="", $cutoff) {
	global $db, $global_pref, $temp_entry;

	// initialize a temporary db..
	$temp_db = new db(FALSE);
	
	$cat = $db->entry['category'];

	// we fetch the next one, until we get one that is set to 'publish'
	$get_prev_amount = 1;
	do {
		$prev_code=$db->get_previous_code($get_prev_amount);
		if ($prev_code) { $temp_entry = $temp_db->read_entry($prev_code); }
		$get_prev_amount++;

		if ($prev_code===FALSE) { break; }

	} while ( !($temp_entry['status']=="publish") || (count(@array_intersect( $temp_entry['category'], $cat)) == 0) );

	unset($temp_db);

	if ($text=="") {
		$text=(isset($Cfg['entrynext'])) ? $global_pref['entrynext'] : "&laquo; <a href='%link%'>%title%</a>";
	}
	if ($cutoff=="") {
		$cutoff=20;
	}

	if ($prev_code) {
		$title= (strlen($temp_entry['title'])>2) ? $temp_entry['title'] : substr($temp_entry['introduction'],0,100);
		$link=make_filelink($prev_code, "", "");
		$output="$text";
		$output=str_replace("%link%", $link, $output);
		$output=str_replace("%code%", $prev_code, $output);
		$output=str_replace("%title%", trimtext($title,$cutoff), $output);
		return $output;
	} else {
		return "";
	}
}





function snippet_label($label) {

	return lang('weblog_text', $label);

}


function snippet_rssbutton() {
	global  $Weblogs, $Current_weblog, $Paths;
	
	$filename = fixpath($Paths['pivot_url']. $Weblogs[$Current_weblog]['rss_path']) . $Weblogs[$Current_weblog]['rss_filename'];

	$output="<a href='".$filename."' title='XML: RSS feed'>";

	// Hack by digits to adjust image size if custom RSS image is used
	$image = $Paths['pivot_url']."pics/rssbutton.png";
	list($width, $height) = @getimagesize($Paths['pivot_path'].'pics/rssbutton.png');
	$output.="<img src='".$image."' width='".$width."' height='".$height."' alt='XML: RSS feed' style='border:0px;' /></a>";
	// End hack

	$output = targetblank($output);

	return $output; 
}



function snippet_atombutton() {
	global  $Weblogs, $Current_weblog, $Paths;

	$filename = fixpath($Paths['pivot_url']. $Weblogs[$Current_weblog]['rss_path']) . $Weblogs[$Current_weblog]['atom_filename'];

	$output="<a href='".$filename."' title='XML: Atom feed'>";

	// Hack by digits to adjust image size if custom RSS image is used
	$image = $Paths['pivot_url']."pics/atombutton.png";
	list($width, $height) = @getimagesize($Paths['pivot_path'].'pics/atombutton.png');
	$output.="<img src='".$image."' width='".$width."' height='".$height."' alt='XML: Atom feed' style='border:0px;' /></a>";
	// End hack

	$output = targetblank($output);

	return $output; 
}


function snippet_rss_autodiscovery() {
	global  $Weblogs, $Current_weblog, $Paths;
	
	$filename = fixpath($Paths['pivot_url']. $Weblogs[$Current_weblog]['rss_path']) . $Weblogs[$Current_weblog]['rss_filename'];

	$output = '<link rel="alternate" type="application/rss+xml" title="RSS" href="'.$filename.'"/>';

	return $output;
}


function snippet_atom_autodiscovery() {
	global  $Weblogs, $Current_weblog, $Paths;
	
	$filename = fixpath($Paths['pivot_url']. $Weblogs[$Current_weblog]['rss_path']) . $Weblogs[$Current_weblog]['atom_filename'];

	$output = '<link rel="alternate" type="application/atom+xml" title="Atom" href="'.$filename.'"/>';

	return $output;
}


function snippet_last_comments() {
	global $Cfg, $db, $Weblogs, $Current_weblog, $temp_entry;

	if (isset($Weblogs[$Current_weblog]['lastcomm_format']) && (strlen($Weblogs[$Current_weblog]['lastcomm_format'])>2)) {
		$last_comments_format = $Weblogs[$Current_weblog]['lastcomm_format'];
	} else {
		$last_comments_format = "<a href='%url%' title='%date%' %popup%><b>%name%</b></a> (%title%): %comm%<br />";
	}

	if (isset($Weblogs[$Current_weblog]['lastcomm_length']) && ($Weblogs[$Current_weblog]['lastcomm_length']>0)) {
		$last_comments_length = $Weblogs[$Current_weblog]['lastcomm_length'];
	} else {
		$last_comments_length = 100;
	}

	if (isset($Weblogs[$Current_weblog]['lastcomm_trim']) && ($Weblogs[$Current_weblog]['lastcomm_trim']>0)) {
		$last_comments_trim = $Weblogs[$Current_weblog]['lastcomm_trim'];
	} else {
		$last_comments_trim = 16;
	}

	if (isset($Weblogs[$Current_weblog]['lastcomm_amount']) && ($Weblogs[$Current_weblog]['lastcomm_amount']>0)) {
		$last_comments_count = $Weblogs[$Current_weblog]['lastcomm_amount'];
	} else {
		$last_comments_count = 10;
	}

	@$file =	array_reverse(load_serialize("db/ser_lastcomm.php", true, true));

	// round up the cats that are shown on this page:
	foreach ($Weblogs[$Current_weblog]['sub_weblog'] as $subweblog) {
			$cats = @array_merge($cats, $subweblog['categories']);
	}


	$output="";

	$count=0;

	if (count($file)>0) {
		foreach ($file as $comment) {

			// if it's in a category that published n the frontpage, and the user is not blocked, we display it.
			if ( (count(array_intersect($comment['category'], $cats))>0) && (!(ip_check_block(trim($comment['ip'])))) && $db->entry_exists($comment['code']) ) {

				$temp_entry['date'] = $db->get_date($comment['code']);
				$temp_entry['title'] = $comment['title'];
				$temp_entry['code'] = $comment['code'];

				$id = safe_string($comment["name"],TRUE) . "-" . format_date($comment["date"], "%ye%%month%%day%%hour24%%minute%");

				$url=make_filelink($comment['code'], "", $id);

				$comment['name'] = trimtext(stripslashes($comment['name']), $last_comments_trim);
				$comment['title'] = trimtext(stripslashes($comment['title']), $last_comments_trim);
				$comment['comment'] = trimtext(stripslashes($comment['comment']), $last_comments_length);
				$comment['comment'] = mywordwrap($comment['comment'], 18, " ", 1);
				$comment['comment'] = str_replace('/', '', $comment['comment']);
		

				if ($Weblogs[$Current_weblog]['comment_pop']==1) {
			
					$popup= sprintf("onclick=\"window.open('%s', 'popuplink', 'width=%s,height=%s,directories=no,location=no,scrollbars=yes,menubar=no,status=yes,toolbar=no,resizable=yes'); return false\"", $url, $Weblogs[$Current_weblog]['comment_width'], $Weblogs[$Current_weblog]['comment_height']);

				} else {
					$popup="";
				}

				$thisline=$last_comments_format;
				$thisline=str_replace("%name%", $comment['name'], $thisline);
				$thisline=str_replace("%date%", $comment['date'], $thisline);
				$thisline=str_replace("%title%", $comment['title'], $thisline);
				$thisline=str_replace("%url%", $url, $thisline);
				$thisline=str_replace("%popup%", $popup, $thisline);
				$thisline=str_replace("%comm%", $comment['comment'], $thisline);

				$thisline=format_date($comment["date"], $thisline);

				$output.= $thisline;

				$count++;
				if ($count>=$last_comments_count) { 
					return $output; 
				}
			}
		}
	}
	return $output;
}



function snippet_emotpopup($title) {
	global $Cfg, $Weblogs, $Current_weblog, $Paths;

	if ($title=="") { $title= lang('weblog_text', 'emoticons'); }

	if ($Weblogs[$Current_weblog]['emoticons']==1) {

		$url=$Paths['pivot_url']."includes/emot/emoticons.html"; 
		$onclick="window.open('$url','emot','width=264,height=234,directories=no,location=no,menubar=no,scrollbars=no,status=yes,toolbar=no,resizable=no');return false";
		$output="<a href='#' onmouseover=\"window.status='(Emoticons Reference)';return true;\" onmouseout=\"window.status='';return true;\" title='Open Emoticons Reference' onclick=\"$onclick\">$title</a>";

	} else {
		$output="";
	}

	return $output;

}


function snippet_textilepopup($title) {
	global $Cfg, $Weblogs, $Current_weblog, $Paths;

	if ($title=="") { $title= lang('weblog_text', 'textile'); }
	
	$desc = lang('weblog_text', 'textile_reference');

	if ($Weblogs[$Current_weblog]['comment_textile']==1) {

		$url=$Paths['pivot_url']."includes/textile/overview.html"; 
		$onclick="window.open('$url','textile','width=350,height=520,directories=no,location=no,menubar=no,scrollbars=no,status=yes,toolbar=no,resizable=no');return false";
		$output="<a href='#' onmouseover=\"window.status='$desc';return true;\" onmouseout=\"window.status='';return true;\" title='$desc' onclick=\"$onclick\">$title</a>";

	} else {
		$output="";
	}

	return $output;

}


function snippet_wastecomment() {

	$output="<input type='button'  style='border: 1px inset black;' value='Waste comment!' onclick=\"this.form.target='_blank'; this.form.action='http://ubique.ch/weblog/waste.pl'; this.form.submit(); if(!document.layers)location.reload()\"> ";

	return $output;

}

function snippet_self() {
	global $db, $Paths;

	return $Paths['host'].make_filelink($db->entry['code'], "","","");	

}

function snippet_singlepermalink($text, $title) {
	global $db, $Cfg, $Weblogs, $Current_weblog;

	$link=make_filelink($db->entry['code'], "","","");


	$text = str_replace('%title%', $db->entry['title'], $text);
	$text = str_replace('%subtitle%', $db->entry['subtitle'], $text);
	$text = format_date($db->entry["date"], $text );

	$title = str_replace('%title%', htmlentities($db->entry['title']), $title);
	$title = str_replace('%subtitle%', htmlentities($db->entry['subtitle']), $title);
	$title = format_date($db->entry["date"], $title ); 
	
	$code = sprintf("<a href=\"%s%s\" title=\"%s\">%s</a>", $Weblogs[$Current_weblog]['ssi_prefix'], $link, $title ,$text);

	return $code;

}


function snippet_permalink($text, $title) {
	global $db, $Cfg, $Weblogs, $Current_weblog;

	$link=make_archive_link()."#e".$db->entry['code'];
	
	$text = str_replace('%title%', $db->entry['title'], $text);
	$text = format_date($db->entry["date"], $text );
	$title = str_replace('%title%', htmlentities($db->entry['title']), $title);
	$title = format_date($db->entry["date"], $title );

	$code=sprintf("<a href=\"%s%s\" title=\"%s\">%s</a>", $Weblogs[$Current_weblog]['ssi_prefix'], $link, $title,$text);

	return $code;

}


function snippet_entrylink() {
	global $db, $Cfg, $Weblogs, $Current_weblog;

	$output=make_filelink($db->entry['code'], "", "");
	
	return $output;
}


function snippet_commentlink() {
	global $db, $Cfg, $Weblogs, $Current_weblog;

	$link=make_filelink($db->entry['code']);

	$commcount=$db->entry['commcount'];

	// special case: If comments are disabled, and there are no
	// comments, just return an empty string..
	if ( ($commcount == 0) &&  ($db->entry['allow_comments'] == 0) )  {
		return "";
	}

	$text = array($Weblogs[$Current_weblog]['comments_text_0'], $Weblogs[$Current_weblog]['comments_text_1'], $Weblogs[$Current_weblog]['comments_text_2']);
	$text = $text[min(2,$commcount)];
	$commcount = lang('numbers', $commcount);
	$commcount = str_replace("%num%", $commcount, $text); 
	$commcount = str_replace("%n%", $db->entry['commcount'], $commcount); 
	$commnames=$db->entry['commnames'];

	if ($commcount=="") { $commcount="(undefined)"; }

	if ($Weblogs[$Current_weblog]['comment_pop']==1) {
		
		$target = set_target('', 'target="_self"');

		$output = sprintf("<a href='%s' ", $link);
		$output.= sprintf("onclick=\"window.open('%s', 'popuplink', 'width=%s,height=%s,directories=no,location=no,scrollbars=yes,menubar=no,status=yes,toolbar=no,resizable=yes'); return false\"", $link, $Weblogs[$Current_weblog]['comment_width'], $Weblogs[$Current_weblog]['comment_height']);
		$output.= sprintf(" title=\"%s\" %s>%s</a>",$commnames, $target, $commcount);
		
	
	} else {

		$output=sprintf("<a href=\"%s\" title=\"%s\">%s</a>", $link, $commnames, $commcount);

	}

	return $output;
}


function snippet_inlinecommentlink() {
	global $db, $Cfg, $Weblogs, $Current_weblog;

	$link=make_filelink($db->entry['code']);

	$commcount=$db->entry['commcount'];

	// special case: If comments are disabled, and there are no
	// comments, just return an empty string..
	if ( ($commcount == 0) && ($db->entry['allow_comments'] == 0) ) {
		return "";
	}

	$text = array($Weblogs[$Current_weblog]['comments_text_0'], $Weblogs[$Current_weblog]['comments_text_1'], $Weblogs[$Current_weblog]['comments_text_2']);
	$text = $text[min(2,$commcount)];
	$commcount = lang('numbers', $commcount);
	$commcount = str_replace("%num%", $commcount, $text); 
	$commcount = str_replace("%n%", $db->entry['commcount'], $commcount); 
	$commnames=$db->entry['commnames'];

	if ($commcount=="") { $commcount="(undefined)"; }

	$target = set_target('', 'target="_self"');

	$output = sprintf("<a href='%s' ", $link);
	$output.= sprintf("onclick=\"openComments('%s', this); return false\"", $db->entry['code']);
	$output.= sprintf(" title=\"%s\" %s>%s</a>",$commnames, $target, $commcount);


	return $output;
}



function snippet_inlinecomments() {
	global $db;

	$output = "<div id='comments_".$db->entry['code']."'></div>";

	return $output;
}


function snippet_inlinemorelink() {
	global $db, $Cfg, $Weblogs, $Current_weblog;

	if (strlen($db->entry['body'])>5) {	

		$link=make_filelink($db->entry['code']);		
		$text= ( strlen($Weblogs[$Current_weblog]['read_more']) > 1 ) ? $Weblogs[$Current_weblog]['read_more'] : "(more)";	

		$target = set_target('', 'target="_self"');

		$output = sprintf("<a href='%s' ", $link);
		$output.= sprintf("onclick=\"openBody('%s', this); return false\"", $db->entry['code']);
		$output.= sprintf("%s>%s</a>", $target, $text);
		return $output;

	} else {
		return "";
	}

}



function snippet_inlinemore() {
	global $db;

	$output = "<div id='body_".$db->entry['code']."'></div>";

	return $output;
}


function snippet_commcount() {
	global $db, $global_pref, $Weblogs, $Current_weblog;

	$this_weblog= $Weblogs[$Current_weblog];

	$commcount=$db->entry['commcount_str'];
	$commnames=$db->entry['commnames'];
	if ($commcount=="") { $commcount="(undefined)"; }

	return $commcount;
}



function snippet_commnames() {
	global $db, $global_pref, $Weblogs, $Current_weblog;

	$this_weblog= $Weblogs[$Current_weblog];

	$commcount=$db->entry['commcount_str'];
	$commnames=$db->entry['commnames'];
	if ($commcount=="") { $commcount="(undefined)"; }

	return $commnames;
}


function snippet_search($nobutton="", $label="") {
	global $Paths;


	$output = "<form method='post' action='".$Paths['pivot_url']."search.php'>\n<input type='text' name='search' class='searchbox' value='' />\n";
	if($nobutton!="nobutton") {
		if($label=="") {
			$label = lang('weblog_text', 'search');
		}
		$output .= "<input type='submit' class='searchbutton' value='".$label."' />\n";
	}
	
	$output .= "</form>\n";

	return $output;

}



function snippet_top() {
	global $db, $global_pref;


	return "";
}


function snippet_show_referrers() {
	global $Weblogs, $Current_weblog, $Paths, $set_output_paths;

	$maxrows = $Weblogs[$Current_weblog]['lastref_amount'];
	$maxlength = $Weblogs[$Current_weblog]['lastref_length'];
	$format = str_replace('"', '\"', ($Weblogs[$Current_weblog]['lastref_format']));

	$ext = strtolower(getextension($Weblogs[$Current_weblog]['front_filename']));
	if ( ($ext=="php") || ($ext=="php3") ) {

		$output = sprintf("<?php \n");
		if(!isset($set_output_paths) || ($set_output_paths==FALSE)) {
			$set_output_paths=TRUE;
			$output .=sprintf("\$log_url='%s';\n ", $Paths['log_url'] );
			$output .=sprintf("\$pivot_url='%s';\n ", $Paths['pivot_url'] );
			$output .= sprintf("\$pivot_path='%s';\n ", $Paths['pivot_path']);
			$output .= sprintf("\$weblog='%s';\n ", $Current_weblog);
		}
		if ($maxrows!="" && is_numeric($maxrows)) { $output .= "\$maxrows = $maxrows; "; }
		if ($maxlength!="" && is_numeric($maxlength)) { $output .= "\$maxlength = $maxlength; "; }
		if ($format!="") { $output .= "\$format = \"$format;\"; "; }
		$output.="include_once '".$Paths['pivot_path']."includes/printref.inc.php'; \n?".">";

	} else {

		$output="<!-- this template tag only works when your frontpage has a .php extension -->";

	}

	//echo(nl2br(htmlentities("$output\n\n")));

	return $output;

}




// an alias for snippet_get_referrer
function snippet_show_referers() {

	return snippet_show_referrers();

}

function snippet_show_referrers_entry() {
	global $Weblogs, $Current_weblog, $base_path, $HTTP_SERVER_VARS, $db, $Cfg, $titles, $maxlength;

	//echo "showref (".$db->entry['title'].")";

	if ($Weblogs[$Current_weblog]['live_entries']==1) {

		$pivot_dir=$base_path;
		include_once "includes/printref_entry.inc.php";

		return $output;
	} else {

		return "<!-- The referers-per-entry only works with live entries -->";
	}

}



function snippet_get_referrer() {
	global $Weblogs, $Current_weblog, $Paths, $set_output_paths;

	$ext = strtolower(getextension($Weblogs[$Current_weblog]['front_filename']));
	if ( ($ext=="php") || ($ext=="php3") ) {
		
		$output = sprintf("<?php \n");
		if(!isset($set_output_paths) || ($set_output_paths==FALSE)) {
			$set_output_paths=TRUE;
			$output .=sprintf("\$log_url='%s';\n ", $Paths['log_url'] );
			$output .=sprintf("\$pivot_url='%s';\n ", $Paths['pivot_url'] );
			$output .= sprintf("\$pivot_path='%s';\n ", $Paths['pivot_path']);
			$output .= sprintf("\$weblog='%s';\n ", $Current_weblog);
		}
		$output.="include_once '".$Paths['pivot_path']."includes/getref.inc.php';\n?".">";

	} else {
		$output="<!-- this template tag only works when your frontpage has a .php extension -->";

	}

	//echo(nl2br(htmlentities("$output\n\n")));


	return $output;

}


// an alias for snippet_get_referrer
function snippet_get_referrers() {

	return snippet_get_referrer();

}


// an alias for snippet_get_referrer
function snippet_get_referer() {

	return snippet_get_referrer();

}



function snippet_home() {
	return get_log_url('index');
}


function snippet_template_dir() {
	global $Paths;

	return $Paths['pivot_url']."templates/";

}


function snippet_pivot_dir() {
	global $Paths;

	return $Paths['pivot_url'];

}

function snippet_pivot_path() {
	global $Paths;

	return $Paths['pivot_path'];

}



function snippet_pivot_url() {
	global $Paths;

	return $Paths['host'].$Paths['pivot_url'];

}


function snippet_log_dir() {
	global $Paths;
	return $Paths['log_url'];
}


function snippet_link_static($titel, $naam) {
 global $global_pref;
 
 $filename="db/static/".$naam.".htm";
 
 if (file_exists($filename)) {
 
  $linkname=str_replace("%1",$naam,$global_pref['file_format']);
  $file="<a href=$linkname>$titel</a>";
 } else {
  $file="<!-- error: could not link $filename. File does not exist -->";
 }
 
 return $file;
}
 

function snippet_static($titel) {
 global $global_pref;
 
 $filename="db/static/".$titel.".htm";
 
 if (file_exists($filename)) {

  $file=implode("", file("$filename"));
 } else {
  $file="<!-- error: could not include $filename. File does not exist -->";
 }
 return $file;
}


function snippet_vote($value, $label, $title="", $total="", $group="") {
	global $Paths, $db, $Current_weblog;

	$url = sprintf("%ssubmit.php?vote=%s&amp;piv_code=%s&amp;piv_weblog=%s&amp;group=%s", $Paths['pivot_url'], urlencode($value), $db->entry['code'], urlencode($Current_weblog), $group);

	if ($total!="") {
		$count = @array_count_values ($db->entry['votes']);
		$count = isset($count[$value]) ? $count[$value] : 0;
		$total = str_replace("%num%", $count, " ".$total);
	}

	$onclick="window.open('$url','emot','width=200,height=100,directories=no,location=no,menubar=no,scrollbars=no,status=yes,toolbar=no,resizable=no');return false";
	$output .= sprintf("<a href='#' onclick=\"%s\" title=\"%s\">%s</a>%s", $onclick, $title, $label, $total);

	return $output;

}

function snippet_karma($value, $label, $label_extra) {
	

	$title = lang('karma', 'vote');
	$title = str_replace('%val%', lang('karma', $value), $title);	

	return snippet_vote($value, $label, $title, '%num% ', "k_");

}

function snippet_message($format="") {
	global $Pivot_Vars;

	if ($format=="") {
		$format="<a id='message'></a><p style='border: 1px dashed #666; padding: 5px;'><b>%message%</b></p>\n\n";
	}

	if (isset($Pivot_Vars['message'])) {
		$message = strip_tags(stripslashes($Pivot_Vars['message']));
		$output = str_replace("%message%", $message, $format);
	} else {
		$output = "";
	}

	return $output;

}


function snippet_close_on_esc() {
	return "<script language='javaScript'>\ndocument.onkeypress = function esc(e) {\nif(typeof(e) == 'undefined') { e=event; }\nif (e.keyCode == 27) { self.close(); }\n}\n</script>\n}";
}

function snippet_calendar_style() {

	$output ="<style type=\"text/css\">

	/* Some default styles for the calendar.. */
	.defcalendar { font-size: 12px;  }
	.defcalendar td { padding: 1px 4px; }
	.defcalendar td:hover { background-color: #FF6; }
	.defcalendarlink { font-size: 10px; }
	.defcalendartoday { background-color: #FF9; border: 1px solid #999; font-weight: bold; }

	</style>
	<"."?php \$default_calender_style = TRUE; ?".">
";

	return $output;

}

function snippet_calendar() {
	global $Paths, $Current_weblog, $set_output_paths;

	$output = sprintf("<?php \n");
	if(!isset($set_output_paths) || ($set_output_paths==FALSE)) {
		$set_output_paths=TRUE;
		$output .=sprintf("\$log_url='%s';\n ", $Paths['log_url'] );
		$output .=sprintf("\$pivot_url='%s';\n ", $Paths['pivot_url'] );
		$output .= sprintf("\$pivot_path='%s';\n ", $Paths['pivot_path']);
		$output .= sprintf("\$weblog='%s';\n ", $Current_weblog);
	}
	$output .= sprintf("include_once \"%sincludes/calendar.php\";\n ?".">", $Paths['pivot_path']);
	

	return $output;

}

function snippet_charset() {
	global $CurrentEncoding;

	if (isset($CurrentEncoding)) {
		return $CurrentEncoding;
	} else {
		return "iso-8859-1";
	}
	
}


function snippet_lang() {
	global $Language, $CurrentLanguage, $CurrentEncoding;

	$lang = $Language[$CurrentLanguage]->getName();

	if ($lang != "" ) {
		return $lang;
	} else {
		return "en";
	}
	
}




function snippet_blogroll_iframe($width, $height) {
	global $Paths, $Weblogs, $Current_weblog;

	$my_weblog = $Weblogs[$Current_weblog];

	$id = $my_weblog['blogroll_id'];

	$fg = (strlen($my_weblog['blogroll_fg'])>0) ? $my_weblog['blogroll_fg'] : "#000";
	$bg = (strlen($my_weblog['blogroll_bg'])>0) ? $my_weblog['blogroll_bg'] : "#FFF";
	$line1 = (strlen($my_weblog['blogroll_line1'])>0) ? $my_weblog['blogroll_line1'] : "#EEE";
	$line2 = (strlen($my_weblog['blogroll_line2'])>0) ? $my_weblog['blogroll_line2'] : "#EEE";
	$c1 = (strlen($my_weblog['blogroll_c1'])>0) ? $my_weblog['blogroll_c1'] : "#90A8BF";
	$c2 = (strlen($my_weblog['blogroll_c2'])>0) ? $my_weblog['blogroll_c2'] : "#ACBECF";
	$c3 = (strlen($my_weblog['blogroll_c3'])>0) ? $my_weblog['blogroll_c3'] : "#C8D4DF";
	$c4 = (strlen($my_weblog['blogroll_c4'])>0) ? $my_weblog['blogroll_c4'] : "#E3E9EF";

	$colors = urlencode(implode("|", array($fg, $bg, $line1, $line2, $c1, $c2, $c3, $c4)));

	$output = sprintf("<iframe src=\"%sincludes/blogroll.php?id=%s&amp;colors=%s\" width=\"%s\" height=\"%s\" frameborder=\"0\" style=\"border:1px; margin:0px;\"></iframe>", $Paths['pivot_url'], $id, $colors, $width, $height );
	
	return $output;

}

function snippet_rss($url, $rssmax, $rssformat) {
	global $Paths, $set_output_paths;

	if ($rssmax=="") { $rssmax=8; }
	if ($rssformat=="") { 
		$rssformat="<b><a href=\"%link%\">%title%</a></b><br /> <small>%description%</small><br />"; 
	}


	$output = "<?php \n\$rssurl=\"$url\";\n";
	$output .= "\$rssmax=$rssmax;\n";
	$output .= "\$rssformat=\"".addslashes($rssformat)."\";\n";
	if(!isset($set_output_paths) || ($set_output_paths==FALSE)) {
		$set_output_paths=TRUE;
		$output .=sprintf("\$log_url='%s';\n ", $Paths['log_url'] );
		$output .=sprintf("\$pivot_url='%s';\n ", $Paths['pivot_url'] );
		$output .= sprintf("\$pivot_path='%s';\n ", $Paths['pivot_path']);
		$output .= sprintf("\$weblog='%s';\n ", $Current_weblog);
	}
	$output.= "include \"".$Paths['pivot_path']."includes/rss.php\"; ?".">";

	return $output;

}


function snippet_bbclone_counter() {
	global $Paths;
	
	
	$path = fixpath($Paths['pivot_path']."../bbclone/");

	$title= snippet_weblogtitle();

	$output = "
	<"."?php
	define(\"_BBC_PAGE_NAME\", \"".addslashes($title)."\" );
	define(\"_BBCLONE_DIR\", \"".$path."\");
	define(\"COUNTER\", _BBCLONE_DIR.\"mark_page.php\");
	if (is_readable(COUNTER)) {
		include_once(COUNTER) ;
	}
	?".">";
	
	return $output;

}

?>
